import { autocompletion as M, closeBrackets as k, completionKeymap as C, closeBracketsKeymap as S } from "@codemirror/autocomplete";
import { indentWithTab as w } from "@codemirror/commands";
import { css as H } from "@codemirror/lang-css";
import { html as N } from "@codemirror/lang-html";
import { json as T } from "@codemirror/lang-json";
import { yaml as V } from "@codemirror/lang-yaml";
import { syntaxHighlighting as K, defaultHighlightStyle as O, indentOnInput as R, bracketMatching as j } from "@codemirror/language";
import { StateEffect as A } from "@codemirror/state";
import { EditorView as c, highlightSpecialChars as B, keymap as a, lineNumbers as I } from "@codemirror/view";
import { ref as L, watch as h, onBeforeUnmount as P, toValue as i, computed as U } from "vue";
import { customTheme as W } from "../themes/index.js";
import { variables as q } from "./variables.js";
const u = (e) => "provider" in e && !!i(e.provider), z = {
  key: "Mod-a",
  run: (e) => (e.dispatch({
    selection: { anchor: 0, head: e.state.doc.length },
    scrollIntoView: !1
  }), !0)
}, oe = (e) => {
  const o = L(null);
  h(
    e.codeMirrorRef,
    () => {
      var t;
      (t = o.value) == null || t.destroy(), l();
    },
    { immediate: !0 }
  ), P(() => {
    var t;
    return (t = o.value) == null ? void 0 : t.destroy();
  });
  function l() {
    if (e.codeMirrorRef.value) {
      const t = u(e) ? i(e.provider) : null, f = v({
        ...s.value,
        provider: t
      });
      o.value = new c({
        parent: e.codeMirrorRef.value,
        extensions: f
      }), u(e) || r(i(e.content));
    }
  }
  const s = U(() => ({
    onChange: e.onChange,
    onBlur: e.onBlur,
    onFocus: e.onFocus,
    language: i(e.language),
    classes: i(e.classes),
    readOnly: i(e.readOnly),
    lineNumbers: i(e.lineNumbers),
    withVariables: i(e.withVariables),
    disableEnter: i(e.withVariables),
    withoutTheme: i(e.withoutTheme),
    additionalExtensions: i(e.extensions)
  }));
  h(
    () => u(e) ? i(e.provider) : null,
    () => {
      var t;
      u(e) && ((t = o.value) == null || t.destroy(), l());
    }
  ), h(
    s,
    () => {
      if (o.value) {
        const t = u(e) ? i(e.provider) : null, f = v({
          ...s.value,
          provider: t
        });
        o.value.dispatch({
          effects: A.reconfigure.of(f)
        });
      } else
        return;
    },
    { immediate: !0 }
  );
  const r = (t = "") => {
    o.value && o.value.state.doc.toString() !== t && o.value.dispatch({
      changes: {
        from: 0,
        to: o.value.state.doc.length,
        insert: t
      },
      selection: {
        anchor: Math.min(
          o.value.state.selection.main.anchor,
          t.length
        )
      }
    });
  };
  return h(
    () => i(e.content),
    () => {
      u(e) || r(i(e.content));
    },
    { immediate: !0 }
  ), {
    /** Replaces the current content with the given value. */
    setCodeMirrorContent: r,
    /** Codemirror instance */
    codeMirror: o
  };
}, g = {
  html: N,
  json: T,
  yaml: V,
  css: H
};
function v({
  onChange: e,
  onBlur: o,
  onFocus: l,
  provider: s,
  language: r,
  classes: t = [],
  readOnly: f = !1,
  lineNumbers: p = !1,
  withVariables: y = !1,
  disableEnter: b = !1,
  withoutTheme: x = !1,
  additionalExtensions: E = []
}) {
  const n = [
    B(),
    K(O, { fallback: !0 }),
    c.theme({
      ".cm-line": {
        lineHeight: "20px"
      },
      ".cm-gutterElement": {
        lineHeight: "20px"
      }
    }),
    // Listen to updates
    c.updateListener.of((d) => {
      d.docChanged && (e == null || e(d.state.doc.toString()));
    }),
    c.domEventHandlers({
      blur: (d, m) => {
        o == null || o(m.state.doc.toString());
      },
      focus: (d, m) => {
        l == null || l(m.state.doc.toString());
      }
    }),
    // Add Classes
    c.editorAttributes.of({ class: t.join(" ") }),
    ...E
  ];
  return s && n.push(s), x || n.push(W), f ? n.push(c.editable.of(!1)) : n.push(
    R(),
    j(),
    M(),
    k(),
    a.of([
      ...C,
      ...S,
      w,
      z
    ])
  ), r && g[r] && n.push(g[r]()), p && n.push(I()), y && n.push(q()), b && n.push(
    a.of([
      {
        key: "Enter",
        run: () => !0
      },
      {
        key: "Ctrl-Enter",
        mac: "Cmd-Enter",
        run: () => !0
      },
      {
        key: "Shift-Enter",
        run: () => !0
      }
    ])
  ), n;
}
export {
  oe as useCodeMirror
};
